<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (39)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="strings">Strings</h1>
    <p>
      In JavaScript, the textual data is stored as strings. There is no separate
      type for a single character.
    </p>
    <p>
      The internal format for strings is always
      <a href="https://en.wikipedia.org/wiki/UTF-16">UTF-16</a>, it is not tied
      to the page encoding.
    </p>
    <h2 id="quotes">Quotes</h2>
    <p>Let’s recall the kinds of quotes.</p>
    <p>
      Strings can be enclosed within either single quotes, double quotes or
      backticks:
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> single <span class="op">=</span> <span class="st">&quot;single-quoted&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="kw">let</span> double <span class="op">=</span> <span class="st">&quot;double-quoted&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-3" title="3"></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="kw">let</span> backticks <span class="op">=</span> <span class="vs">`backticks`</span><span class="op">;</span></a></code></pre>
    </div>
    <p>
      Single and double quotes are essentially the same. Backticks, however,
      allow us to embed any expression into the string, by wrapping it in
      <code>${…}</code>:
    </p>
    <p>```js run function sum(a, b) { return a + b; }</p>
    <p>alert(<code>1 + 2 = ${sum(1, 2)}.</code>); // 1 + 2 = 3. ```</p>
    <p>
      Another advantage of using backticks is that they allow a string to span
      multiple lines:
    </p>
    <p>``<code>js run let guestList =</code>Guests: * John * Pete * Mary `;</p>
    <p>alert(guestList); // a list of guests, multiple lines ```</p>
    <p>
      Looks natural, right? But single or double quotes do not work this way.
    </p>
    <p>If we use them and try to use multiple lines, there’ll be an error:</p>
    <p>
      <code
        >js run let guestList = "Guests: // Error: Unexpected token ILLEGAL *
        John";</code
      >
    </p>
    <p>
      Single and double quotes come from ancient times of language creation when
      the need for multiline strings was not taken into account. Backticks
      appeared much later and thus are more versatile.
    </p>
    <p>
      Backticks also allow us to specify a “template function” before the first
      backtick. The syntax is: <code>func`string`</code>. The function
      <code>func</code> is called automatically, receives the string and
      embedded expressions and can process them. This is called “tagged
      templates”. This feature makes it easier to implement custom templating,
      but is rarely used in practice. You can read more about it in the
      <a href="mdn:/JavaScript/Reference/Template_literals#Tagged_templates"
        >manual</a
      >.
    </p>
    <h2 id="special-characters">Special characters</h2>
    <p>
      It is still possible to create multiline strings with single and double
      quotes by using a so-called “newline character”, written as
      <code>\n</code>, which denotes a line break:
    </p>
    <p>```js run let guestList = “Guests:JohnPeteMary”;</p>
    <p>alert(guestList); // a multiline list of guests ```</p>
    <p>For example, these two lines are equal, just written differently:</p>
    <p>```js run let str1 = “Hello”; // two lines using a “newline symbol”</p>
    <p>
      // two lines using a normal newline and backticks let str2 =
      <code>Hello World</code>;
    </p>
    <p>alert(str1 == str2); // true ```</p>
    <p>There are other, less common “special” characters.</p>
    <p>Here’s the full list:</p>
    <table>
      <colgroup>
        <col style="width: 19%" />
        <col style="width: 81%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Character</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>\n</code></td>
          <td>New line</td>
        </tr>
        <tr class="even">
          <td><code>\r</code></td>
          <td>
            Carriage return: not used alone. Windows text files use a
            combination of two characters <code>\r\n</code> to represent a line
            break.
          </td>
        </tr>
        <tr class="odd">
          <td><code>\'</code>, <code>\"</code></td>
          <td>Quotes</td>
        </tr>
        <tr class="even">
          <td><code>\\</code></td>
          <td>Backslash</td>
        </tr>
        <tr class="odd">
          <td><code>\t</code></td>
          <td>Tab</td>
        </tr>
        <tr class="even">
          <td><code>\b</code>, <code>\f</code>, <code>\v</code></td>
          <td>
            Backspace, Form Feed, Vertical Tab – kept for compatibility, not
            used nowadays.
          </td>
        </tr>
        <tr class="odd">
          <td><code>\xXX</code></td>
          <td>
            Unicode character with the given hexadecimal Unicode
            <code>XX</code>, e.g. <code>'\x7A'</code> is the same as
            <code>'z'</code>.
          </td>
        </tr>
        <tr class="even">
          <td><code>\uXXXX</code></td>
          <td>
            A Unicode symbol with the hex code <code>XXXX</code> in UTF-16
            encoding, for instance <code>\u00A9</code> – is a Unicode for the
            copyright symbol <code>©</code>. It must be exactly 4 hex digits.
          </td>
        </tr>
        <tr class="odd">
          <td><code>\u{X…XXXXXX}</code> (1 to 6 hex characters)</td>
          <td>
            A Unicode symbol with the given UTF-32 encoding. Some rare
            characters are encoded with two Unicode symbols, taking 4 bytes.
            This way we can insert long codes.
          </td>
        </tr>
      </tbody>
    </table>
    <p>Examples with Unicode:</p>
    <p>
      <code
        >js run alert("\u00A9"); // © alert("\u{20331}"); // 佫, a rare Chinese
        hieroglyph (long Unicode) alert("\u{1F60D}"); // 😍, a smiling face
        symbol (another long Unicode)</code
      >
    </p>
    <p>
      All special characters start with a backslash character <code>\</code>. It
      is also called an “escape character”.
    </p>
    <p>We might also use it if we wanted to insert a quote into the string.</p>
    <p>For instance:</p>
    <p>
      <code
        >js run alert("I*!*'*/!*m the Walrus!"); // *!*I'm*/!* the Walrus!</code
      >
    </p>
    <p>
      As you can see, we have to prepend the inner quote by the backslash
      <code>\'</code>, because otherwise it would indicate the string end.
    </p>
    <p>
      Of course, only the quotes that are the same as the enclosing ones need to
      be escaped. So, as a more elegant solution, we could switch to double
      quotes or backticks instead:
    </p>
    <p><code>js run alert(`I'm the Walrus!`); // I'm the Walrus!</code></p>
    <p>
      Note that the backslash <code>\</code> serves for the correct reading of
      the string by JavaScript, then disappears. The in-memory string has no
      <code>\</code>. You can clearly see that in <code>alert</code> from the
      examples above.
    </p>
    <p>
      But what if we need to show an actual backslash <code>\</code> within the
      string?
    </p>
    <p>That’s possible, but we need to double it like <code>\\</code>:</p>
    <p><code>js run alert(`The backslash: \\`); // The backslash: \</code></p>
    <h2 id="string-length">String length</h2>
    <p>The <code>length</code> property has the string length:</p>
    <p><code>js run alert(`My\n`.length); // 3</code></p>
    <p>
      Note that <code>\n</code> is a single “special” character, so the length
      is indeed <code>3</code>.
    </p>
    <p>
      ``<code>warn header="</code>length<code
        >is a property" People with a background in some other languages
        sometimes mistype by calling</code
      >str.length()<code>instead of just</code>str.length`. That doesn’t work.
    </p>
    <p>
      Please note that <code>str.length</code> is a numeric property, not a
      function. There is no need to add parenthesis after it.
    </p>
    <pre><code>
## Accessing characters

To get a character at position `pos`, use square brackets `[pos]` or call the method [str.charAt(pos)](mdn:js/String/charAt). The first character starts from the zero position:

```js run
let str = `Hello`;

// the first character
alert( str[0] ); // H
alert( str.charAt(0) ); // H

// the last character
alert( str[str.length - 1] ); // o</code></pre>
    <p>
      The square brackets are a modern way of getting a character, while
      <code>charAt</code> exists mostly for historical reasons.
    </p>
    <p>
      The only difference between them is that if no character is found,
      <code>[]</code> returns <code>undefined</code>, and
      <code>charAt</code> returns an empty string:
    </p>
    <p>``<code>js run let str =</code>Hello`;</p>
    <p>
      alert(str[1000]); // undefined alert(str.charAt(1000)); // ’’ (an empty
      string) ```
    </p>
    <p>We can also iterate over characters using <code>for..of</code>:</p>
    <p>
      <code
        >js run for (let char of "Hello") { alert(char); // H,e,l,l,o (char
        becomes "H", then "e", then "l" etc) }</code
      >
    </p>
    <h2 id="strings-are-immutable">Strings are immutable</h2>
    <p>
      Strings can’t be changed in JavaScript. It is impossible to change a
      character.
    </p>
    <p>Let’s try it to show that it doesn’t work:</p>
    <p>```js run let str = “Hi”;</p>
    <p>str[0] = “h”; // error alert(str[0]); // doesn’t work ```</p>
    <p>
      The usual workaround is to create a whole new string and assign it to
      <code>str</code> instead of the old one.
    </p>
    <p>For instance:</p>
    <p>```js run let str = “Hi”;</p>
    <p>str = “h” + str[1]; // replace the string</p>
    <p>alert(str); // hi ```</p>
    <p>In the following sections we’ll see more examples of this.</p>
    <h2 id="changing-the-case">Changing the case</h2>
    <p>
      Methods <a href="mdn:js/String/toLowerCase">toLowerCase()</a> and
      <a href="mdn:js/String/toUpperCase">toUpperCase()</a> change the case:
    </p>
    <p>
      <code
        >js run alert("Interface".toUpperCase()); // INTERFACE
        alert("Interface".toLowerCase()); // interface</code
      >
    </p>
    <p>Or, if we want a single character lowercased:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="at">alert</span>(<span class="st">&quot;Interface&quot;</span>[<span class="dv">0</span>].<span class="at">toLowerCase</span>())<span class="op">;</span> <span class="co">// &#39;i&#39;</span></a></code></pre>
    </div>
    <h2 id="searching-for-a-substring">Searching for a substring</h2>
    <p>There are multiple ways to look for a substring within a string.</p>
    <h3 id="str.indexof">str.indexOf</h3>
    <p>
      The first method is
      <a href="mdn:js/String/indexOf">str.indexOf(substr, pos)</a>.
    </p>
    <p>
      It looks for the <code>substr</code> in <code>str</code>, starting from
      the given position <code>pos</code>, and returns the position where the
      match was found or <code>-1</code> if nothing can be found.
    </p>
    <p>For instance:</p>
    <p>```js run let str = “Widget with id”;</p>
    <p>
      alert(str.indexOf(“Widget”)); // 0, because ‘Widget’ is found at the
      beginning alert(str.indexOf(“widget”)); // -1, not found, the search is
      case-sensitive
    </p>
    <p>
      alert(str.indexOf(“id”)); // 1, “id” is found at the position 1 (..idget
      with id) ```
    </p>
    <p>
      The optional second parameter allows us to start searching from a given
      position.
    </p>
    <p>
      For instance, the first occurrence of <code>"id"</code> is at position
      <code>1</code>. To look for the next occurrence, let’s start the search
      from position <code>2</code>:
    </p>
    <p>```js run let str = “Widget with id”;</p>
    <p>alert(str.indexOf(“id”, 2)); // 12 ```</p>
    <p>
      If we’re interested in all occurrences, we can run <code>indexOf</code> in
      a loop. Every new call is made with the position after the previous match:
    </p>
    <p>```js run let str = “As sly as a fox, as strong as an ox”;</p>
    <p>let target = “as”; // let’s look for it</p>
    <p>
      let pos = 0; while (true) { let foundPos = str.indexOf(target, pos); if
      (foundPos == -1) break;
    </p>
    <p>
      alert(<code>Found at ${foundPos}</code>); pos = foundPos + 1; // continue
      the search from the next position } ```
    </p>
    <p>The same algorithm can be layed out shorter:</p>
    <p>
      ```js run let str = “As sly as a fox, as strong as an ox”; let target =
      “as”;
    </p>
    <p>
      <em>!</em> let pos = -1; while ((pos = str.indexOf(target, pos + 1)) !=
      -1) { alert( pos ); } <em>/!</em> ```
    </p>
    <p>
      ``<code>smart header="</code>str.lastIndexOf(substr, position)`" There is
      also a similar method
      <a href="mdn:js/String/lastIndexOf">str.lastIndexOf(substr, position)</a>
      that searches from the end of a string to its beginning.
    </p>
    <p>It would list the occurrences in the reverse order.</p>
    <pre><code>
There is a slight inconvenience with `indexOf` in the `if` test. We can&#39;t put it in the `if` like this:

```js run
let str = &quot;Widget with id&quot;;

if (str.indexOf(&quot;Widget&quot;)) {
    alert(&quot;We found it&quot;); // doesn&#39;t work!
}</code></pre>
    <p>
      The <code>alert</code> in the example above doesn’t show because
      <code>str.indexOf("Widget")</code> returns <code>0</code> (meaning that it
      found the match at the starting position). Right, but
      <code>if</code> considers <code>0</code> to be <code>false</code>.
    </p>
    <p>So, we should actually check for <code>-1</code>, like this:</p>
    <p>```js run let str = “Widget with id”;</p>
    <p>
      <em>!</em> if (str.indexOf(“Widget”) != -1) { <em>/!</em> alert(“We found
      it”); // works now! } ```
    </p>
    <h4 id="the-bitwise-not-trick">The bitwise NOT trick</h4>
    <p>
      One of the old tricks used here is the
      <a
        href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/Bitwise_NOT"
        >bitwise NOT</a
      >
      <code>~</code> operator. It converts the number to a 32-bit integer
      (removes the decimal part if exists) and then reverses all bits in its
      binary representation.
    </p>
    <p>
      In practice, that means a simple thing: for 32-bit integers
      <code>~n</code> equals <code>-(n+1)</code>.
    </p>
    <p>For instance:</p>
    <p>
      <code
        >js run alert( ~2 ); // -3, the same as -(2+1) alert( ~1 ); // -2, the
        same as -(1+1) alert( ~0 ); // -1, the same as -(0+1) *!* alert( ~-1 );
        // 0, the same as -(-1+1) */!*</code
      >
    </p>
    <p>
      As we can see, <code>~n</code> is zero only if
      <code>n == -1</code> (that’s for any 32-bit signed integer
      <code>n</code>).
    </p>
    <p>
      So, the test <code>if ( ~str.indexOf("...") )</code> is truthy only if the
      result of <code>indexOf</code> is not <code>-1</code>. In other words,
      when there is a match.
    </p>
    <p>People use it to shorten <code>indexOf</code> checks:</p>
    <p>```js run let str = “Widget”;</p>
    <p>if (~str.indexOf(“Widget”)) { alert(“Found it!”); // works } ```</p>
    <p>
      It is usually not recommended to use language features in a non-obvious
      way, but this particular trick is widely used in old code, so we should
      understand it.
    </p>
    <p>
      Just remember: <code>if (~str.indexOf(...))</code> reads as “if found”.
    </p>
    <p>
      To be precise though, as big numbers are truncated to 32 bits by
      <code>~</code> operator, there exist other numbers that give
      <code>0</code>, the smallest is <code>~4294967295=0</code>. That makes
      such check correct only if a string is not that long.
    </p>
    <p>
      Right now we can see this trick only in the old code, as modern JavaScript
      provides <code>.includes</code> method (see below).
    </p>
    <h3 id="includes-startswith-endswith">includes, startsWith, endsWith</h3>
    <p>
      The more modern method
      <a href="mdn:js/String/includes">str.includes(substr, pos)</a> returns
      <code>true/false</code> depending on whether <code>str</code> contains
      <code>substr</code> within.
    </p>
    <p>
      It’s the right choice if we need to test for the match, but don’t need its
      position:
    </p>
    <p>```js run alert(“Widget with id”.includes(“Widget”)); // true</p>
    <p>alert(“Hello”.includes(“Bye”)); // false ```</p>
    <p>
      The optional second argument of <code>str.includes</code> is the position
      to start searching from:
    </p>
    <p>
      <code
        >js run alert("Widget".includes("id")); // true
        alert("Widget".includes("id", 3)); // false, from position 3 there is no
        "id"</code
      >
    </p>
    <p>
      The methods <a href="mdn:js/String/startsWith">str.startsWith</a> and
      <a href="mdn:js/String/endsWith">str.endsWith</a> do exactly what they
      say:
    </p>
    <p>
      <code
        >js run alert("Widget".startsWith("Wid")); // true, "Widget" starts with
        "Wid" alert("Widget".endsWith("get")); // true, "Widget" ends with
        "get"</code
      >
    </p>
    <h2 id="getting-a-substring">Getting a substring</h2>
    <p>
      There are 3 methods in JavaScript to get a substring:
      <code>substring</code>, <code>substr</code> and <code>slice</code>.
    </p>
    <dl>
      <dt><code>str.slice(start [, end])</code></dt>
      <dd>
        <p>
          Returns the part of the string from <code>start</code> to (but not
          including) <code>end</code>.
        </p>
        <p>For instance:</p>
        <p>
          <code
            >js run let str = "stringify"; alert( str.slice(0, 5) ); // 'strin',
            the substring from 0 to 5 (not including 5) alert( str.slice(0, 1)
            ); // 's', from 0 to 1, but not including 1, so only character at
            0</code
          >
        </p>
        <p>
          If there is no second argument, then <code>slice</code> goes till the
          end of the string:
        </p>
        <p>
          <code
            >js run let str = "st*!*ringify*/!*"; alert( str.slice(2) ); //
            'ringify', from the 2nd position till the end</code
          >
        </p>
        <p>
          Negative values for <code>start/end</code> are also possible. They
          mean the position is counted from the string end:
        </p>
        <p>```js run let str = “strin<em>!</em>gif<em>/!</em>y”;</p>
        <p>
          // start at the 4th position from the right, end at the 1st from the
          right alert( str.slice(-4, -1) ); // ‘gif’ ```
        </p>
      </dd>
      <dt><code>str.substring(start [, end])</code></dt>
      <dd>
        <p>
          Returns the part of the string <em>between</em> <code>start</code> and
          <code>end</code>.
        </p>
        <p>
          This is almost the same as <code>slice</code>, but it allows
          <code>start</code> to be greater than <code>end</code>.
        </p>
        <p>For instance:</p>
        <p>```js run let str = “st<em>!</em>ring<em>/!</em>ify”;</p>
        <p>
          // these are same for substring alert( str.substring(2, 6) ); //
          “ring” alert( str.substring(6, 2) ); // “ring”
        </p>
        <p>
          // …but not for slice: alert( str.slice(2, 6) ); // “ring” (the same)
          alert( str.slice(6, 2) ); // "" (an empty string)
        </p>
        <p>```</p>
        <p>
          Negative arguments are (unlike slice) not supported, they are treated
          as <code>0</code>.
        </p>
      </dd>
      <dt><code>str.substr(start [, length])</code></dt>
      <dd>
        <p>
          Returns the part of the string from <code>start</code>, with the given
          <code>length</code>.
        </p>
        <p>
          In contrast with the previous methods, this one allows us to specify
          the <code>length</code> instead of the ending position:
        </p>
        <p>
          <code
            >js run let str = "st*!*ring*/!*ify"; alert( str.substr(2, 4) ); //
            'ring', from the 2nd position get 4 characters</code
          >
        </p>
        <p>The first argument may be negative, to count from the end:</p>
        <p>
          <code
            >js run let str = "strin*!*gi*/!*fy"; alert( str.substr(-4, 2) ); //
            'gi', from the 4th position get 2 characters</code
          >
        </p>
      </dd>
    </dl>
    <p>Let’s recap these methods to avoid any confusion:</p>
    <table>
      <colgroup>
        <col style="width: 25%" />
        <col style="width: 47%" />
        <col style="width: 26%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>method</th>
          <th>selects…</th>
          <th>negatives</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>slice(start, end)</code></td>
          <td>
            from <code>start</code> to <code>end</code> (not including
            <code>end</code>)
          </td>
          <td>allows negatives</td>
        </tr>
        <tr class="even">
          <td><code>substring(start, end)</code></td>
          <td>between <code>start</code> and <code>end</code></td>
          <td>negative values mean <code>0</code></td>
        </tr>
        <tr class="odd">
          <td><code>substr(start, length)</code></td>
          <td>from <code>start</code> get <code>length</code> characters</td>
          <td>allows negative <code>start</code></td>
        </tr>
      </tbody>
    </table>
    <p>
      ``<code
        >smart header="Which one to choose?" All of them can do the job.
        Formally,</code
      >substr` has a minor drawback: it is described not in the core JavaScript
      specification, but in Annex B, which covers browser-only features that
      exist mainly for historical reasons. So, non-browser environments may fail
      to support it. But in practice it works everywhere.
    </p>
    <p>
      Of the other two variants, <code>slice</code> is a little bit more
      flexible, it allows negative arguments and shorter to write. So, it’s
      enough to remember solely <code>slice</code> of these three methods. ```
    </p>
    <h2 id="comparing-strings">Comparing strings</h2>
    <p>
      As we know from the chapter
      <a href="info:comparison" class="uri">info:comparison</a>, strings are
      compared character-by-character in alphabetical order.
    </p>
    <p>Although, there are some oddities.</p>
    <ol type="1">
      <li>
        <p>A lowercase letter is always greater than the uppercase:</p>
        <p><code>js run alert("a" &gt; "Z"); // true</code></p>
      </li>
      <li>
        <p>Letters with diacritical marks are “out of order”:</p>
        <p><code>js run alert("Österreich" &gt; "Zealand"); // true</code></p>
        <p>
          This may lead to strange results if we sort these country names.
          Usually people would expect <code>Zealand</code> to come after
          <code>Österreich</code> in the list.
        </p>
      </li>
    </ol>
    <p>
      To understand what happens, let’s review the internal representation of
      strings in JavaScript.
    </p>
    <p>
      All strings are encoded using
      <a href="https://en.wikipedia.org/wiki/UTF-16">UTF-16</a>. That is: each
      character has a corresponding numeric code. There are special methods that
      allow to get the character for the code and back.
    </p>
    <dl>
      <dt><code>str.codePointAt(pos)</code></dt>
      <dd>
        <p>Returns the code for the character at position <code>pos</code>:</p>
        <p>
          <code
            >js run // different case letters have different codes alert(
            "z".codePointAt(0) ); // 122 alert( "Z".codePointAt(0) ); //
            90</code
          >
        </p>
      </dd>
      <dt><code>String.fromCodePoint(code)</code></dt>
      <dd>
        <p>Creates a character by its numeric <code>code</code></p>
        <p><code>js run alert( String.fromCodePoint(90) ); // Z</code></p>
        <p>
          We can also add Unicode characters by their codes using
          <code>\u</code> followed by the hex code:
        </p>
        <p>
          <code
            >js run // 90 is 5a in hexadecimal system alert( '\u005a' ); //
            Z</code
          >
        </p>
      </dd>
    </dl>
    <p>
      Now let’s see the characters with codes <code>65..220</code> (the latin
      alphabet and a little bit extra) by making a string of them:
    </p>
    <p>```js run let str = "";</p>
    <p>
      for (let i = 65; i &lt;= 220; i++) { str += String.fromCodePoint(i); }
      alert(str); //
      ABCDEFGHIJKLMNOPQRSTUVWXYZ[]^_`abcdefghijklmnopqrstuvwxyz{|}~ //
      ¡¢£¤¥¦§¨©ª«¬­®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜ ```
    </p>
    <p>
      See? Capital characters go first, then a few special ones, then lowercase
      characters, and <code>Ö</code> near the end of the output.
    </p>
    <p>Now it becomes obvious why <code>a &gt; Z</code>.</p>
    <p>
      The characters are compared by their numeric code. The greater code means
      that the character is greater. The code for <code>a</code> (97) is greater
      than the code for <code>Z</code> (90).
    </p>
    <ul>
      <li>
        All lowercase letters go after uppercase letters because their codes are
        greater.
      </li>
      <li>
        Some letters like <code>Ö</code> stand apart from the main alphabet.
        Here, it’s code is greater than anything from <code>a</code> to
        <code>z</code>.
      </li>
    </ul>
    <h3 id="correct-comparisons-correct-comparisons">
      Correct comparisons [#correct-comparisons]
    </h3>
    <p>
      The “right” algorithm to do string comparisons is more complex than it may
      seem, because alphabets are different for different languages.
    </p>
    <p>So, the browser needs to know the language to compare.</p>
    <p>
      Luckily, all modern browsers (IE10- requires the additional library
      <a href="https://github.com/andyearnshaw/Intl.js/">Intl.js</a>) support
      the internationalization standard
      <a href="http://www.ecma-international.org/ecma-402/1.0/ECMA-402.pdf"
        >ECMA-402</a
      >.
    </p>
    <p>
      It provides a special method to compare strings in different languages,
      following their rules.
    </p>
    <p>
      The call
      <a href="mdn:js/String/localeCompare">str.localeCompare(str2)</a> returns
      an integer indicating whether <code>str</code> is less, equal or greater
      than <code>str2</code> according to the language rules:
    </p>
    <ul>
      <li>
        Returns a negative number if <code>str</code> is less than
        <code>str2</code>.
      </li>
      <li>
        Returns a positive number if <code>str</code> is greater than
        <code>str2</code>.
      </li>
      <li>Returns <code>0</code> if they are equivalent.</li>
    </ul>
    <p>For instance:</p>
    <p>
      <code>js run alert("Österreich".localeCompare("Zealand")); // -1</code>
    </p>
    <p>
      This method actually has two additional arguments specified in
      <a href="mdn:js/String/localeCompare">the documentation</a>, which allows
      it to specify the language (by default taken from the environment, letter
      order depends on the language) and setup additional rules like case
      sensitivity or should <code>"a"</code> and <code>"á"</code> be treated as
      the same etc.
    </p>
    <h2 id="internals-unicode">Internals, Unicode</h2>
    <p>
      ```warn header=“Advanced knowledge” The section goes deeper into string
      internals. This knowledge will be useful for you if you plan to deal with
      emoji, rare mathematical or hieroglyphic characters or other rare symbols.
    </p>
    <p>You can skip the section if you don’t plan to support them. ```</p>
    <h3 id="surrogate-pairs">Surrogate pairs</h3>
    <p>
      All frequently used characters have 2-byte codes. Letters in most european
      languages, numbers, and even most hieroglyphs, have a 2-byte
      representation.
    </p>
    <p>
      But 2 bytes only allow 65536 combinations and that’s not enough for every
      possible symbol. So rare symbols are encoded with a pair of 2-byte
      characters called “a surrogate pair”.
    </p>
    <p>The length of such symbols is <code>2</code>:</p>
    <p>
      <code
        >js run alert("𝒳".length); // 2, MATHEMATICAL SCRIPT CAPITAL X
        alert("😂".length); // 2, FACE WITH TEARS OF JOY alert("𩷶".length); //
        2, a rare Chinese hieroglyph</code
      >
    </p>
    <p>
      Note that surrogate pairs did not exist at the time when JavaScript was
      created, and thus are not correctly processed by the language!
    </p>
    <p>
      We actually have a single symbol in each of the strings above, but the
      <code>length</code> shows a length of <code>2</code>.
    </p>
    <p>
      <code>String.fromCodePoint</code> and <code>str.codePointAt</code> are few
      rare methods that deal with surrogate pairs right. They recently appeared
      in the language. Before them, there were only
      <a href="mdn:js/String/fromCharCode">String.fromCharCode</a> and
      <a href="mdn:js/String/charCodeAt">str.charCodeAt</a>. These methods are
      actually the same as <code>fromCodePoint/codePointAt</code>, but don’t
      work with surrogate pairs.
    </p>
    <p>
      Getting a symbol can be tricky, because surrogate pairs are treated as two
      characters:
    </p>
    <p>
      <code
        >js run alert("𝒳"[0]); // strange symbols... alert("𝒳"[1]); // ...pieces
        of the surrogate pair</code
      >
    </p>
    <p>
      Note that pieces of the surrogate pair have no meaning without each other.
      So the alerts in the example above actually display garbage.
    </p>
    <p>
      Technically, surrogate pairs are also detectable by their codes: if a
      character has the code in the interval of <code>0xd800..0xdbff</code>,
      then it is the first part of the surrogate pair. The next character
      (second part) must have the code in interval <code>0xdc00..0xdfff</code>.
      These intervals are reserved exclusively for surrogate pairs by the
      standard.
    </p>
    <p>In the case above:</p>
    <p>
      ```js run // charCodeAt is not surrogate-pair aware, so it gives codes for
      parts
    </p>
    <p>
      alert(“𝒳”.charCodeAt(0).toString(16)); // d835, between 0xd800 and 0xdbff
      alert(“𝒳”.charCodeAt(1).toString(16)); // dcb3, between 0xdc00 and 0xdfff
      ```
    </p>
    <p>
      You will find more ways to deal with surrogate pairs later in the chapter
      <a href="info:iterable" class="uri">info:iterable</a>. There are probably
      special libraries for that too, but nothing famous enough to suggest here.
    </p>
    <h3 id="diacritical-marks-and-normalization">
      Diacritical marks and normalization
    </h3>
    <p>
      In many languages there are symbols that are composed of the base
      character with a mark above/under it.
    </p>
    <p>
      For instance, the letter <code>a</code> can be the base character for:
      <code>àáâäãåā</code>. Most common “composite” character have their own
      code in the UTF-16 table. But not all of them, because there are too many
      possible combinations.
    </p>
    <p>
      To support arbitrary compositions, UTF-16 allows us to use several Unicode
      characters: the base character followed by one or many “mark” characters
      that “decorate” it.
    </p>
    <p>
      For instance, if we have <code>S</code> followed by the special “dot
      above” character (code <code>\u0307</code>), it is shown as Ṡ.
    </p>
    <p><code>js run alert("S\u0307"); // Ṡ</code></p>
    <p>
      If we need an additional mark above the letter (or below it) – no problem,
      just add the necessary mark character.
    </p>
    <p>
      For instance, if we append a character “dot below” (code
      <code>\u0323</code>), then we’ll have “S with dots above and below”:
      <code>Ṩ</code>.
    </p>
    <p>For example:</p>
    <p><code>js run alert("S\u0307\u0323"); // Ṩ</code></p>
    <p>
      This provides great flexibility, but also an interesting problem: two
      characters may visually look the same, but be represented with different
      Unicode compositions.
    </p>
    <p>For instance:</p>
    ```js run let s1 = "S
  </body>
</html>
